<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FuncoesService;

class FuncoesController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $FuncoesService;
   
    public function __construct($crudService, $environment, FuncoesService $FuncoesService) {
        parent::__construct($crudService, $environment);
        $this->FuncoesService = $FuncoesService;
    }

    // Busca uma lista com todas funções com algumas informações
    public function getPositionsController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();

        $var = $this->FuncoesService->getPositionsService($params);
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    // Busca uma lista com todas as funções, só nome e id
    public function positionsListController(DTO\Request $request, DTO\Response $response) {
        $var = $this->FuncoesService->positionsListService();
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function createPositionController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();

        $nmperfilacesso = $params['params']['NMPERFILACESSO'];
        $nmperfilacesso = $params['params']['NMPERFILACESSO'];
        $idpermisssusuario = $params['params']['IDPERMISSSUSUARIO'];
        $idpermissstarefas = $params['params']['IDPERMISSSTAREFAS'];
        $idpermissslocais = $params['params']['IDPERMISSSLOCAIS'];
        $idpermissschecklist = $params['params']['IDPERMISSSCHECKLIST'];
        $idpermisssrelatorios = $params['params']['IDPERMISSSRELATORIOS'];
        $idpermisssgraficos = $params['params']['IDPERMISSSGRAFICOS'];
        $idpermisssvistoria = $params['params']['IDPERMISSSVISTORIA'];
        $idpermissscalend = $params['params']['IDPERMISSSCALEND'];
        $iddirecionaqrcode = $params['params']['IDDIRECIONAQRCODE'];
        $idtipodashboard = $params['params']['IDTIPODASHBOARD'];
        
        $var = $this->FuncoesService->createPositionService($nmperfilacesso, $idpermisssusuario, $idpermissstarefas, $idpermissslocais, $idpermissschecklist, $idpermisssrelatorios, $idpermisssgraficos, $idpermisssvistoria, $idpermissscalend, $iddirecionaqrcode,  $idtipodashboard);
        $dtsVal = new DataSet('info', array("message" => $var));
        $response->addDataSet($dtsVal);
    }
    
    // Busca uma função específica e todas suas informações
    public function getPositionInfoController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        
        $var = $this->FuncoesService->getPositionInfoService($params["id"]);
        $dtsVal = new DataSet("info", $var);
        $response->addDataSet($dtsVal);
    }
    
    public function updatePositionController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        
        $nrperfilacesso = $params['params']['NRPERFILACESSO'];
        $nmperfilacesso = $params['params']['NMPERFILACESSO'];
        $idpermisssusuario = $params['params']['IDPERMISSSUSUARIO'];
        $idpermissstarefas = $params['params']['IDPERMISSSTAREFAS'];
        $idpermissslocais = $params['params']['IDPERMISSSLOCAIS'];
        $idpermissschecklist = $params['params']['IDPERMISSSCHECKLIST'];
        $idpermisssrelatorios = $params['params']['IDPERMISSSRELATORIOS'];
        $idpermisssgraficos = $params['params']['IDPERMISSSGRAFICOS'];
        $idpermisssvistoria = $params['params']['IDPERMISSSVISTORIA'];
        $idpermissscalend = $params['params']['IDPERMISSSCALEND'];
        $iddirecionaqrcode = $params['params']['IDDIRECIONAQRCODE'];
        $idtipodashboard = $params['params']['IDTIPODASHBOARD'];
        
        $var = $this->FuncoesService->updatePositionService($nrperfilacesso, $nmperfilacesso, $idpermisssusuario, $idpermissstarefas, $idpermissslocais, $idpermissschecklist, $idpermisssrelatorios, $idpermisssgraficos, $idpermisssvistoria, $idpermissscalend, $iddirecionaqrcode, $idtipodashboard);
        $dtsVal = new DataSet('info', array("message" => $var));
        $response->addDataSet($dtsVal);
    }
    
    public function deletePositionsController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();

        $var = $this->FuncoesService->deletePositionsService($params);
        $dtsVal = new DataSet('info', array("resultado" => $var));
        $response->addDataSet($dtsVal);
    }
    
    // Busca qual as permissões para o usuário logado
    public function getPositionPermiss(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $nrfuncionario = $params['id'];
        
        $var = $this->FuncoesService->getPositionPermiss($nrfuncionario);
        $dtsVal = new DataSet("info", $var);
        $response->addDataSet($dtsVal);
    }

}
?>