<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\GerenciamentoChkService;

class GerenciamentoChkController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $GerenciamentoChkService;
   
    public function __construct($crudService, $environment, GerenciamentoChkService $GerenciamentoChkService) {
        parent::__construct($crudService, $environment);
        $this->GerenciamentoChkService = $GerenciamentoChkService;
    }

    public function listInspectionTask(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->GerenciamentoChkService->listInspectionTask($params);
        $dtsVal = new DataSet("inspectionTask", $var);
        $response->addDataSet($dtsVal);
    }

    public function transferVistoria(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->GerenciamentoChkService->transferVistoria($params);
        $dtsVal = new DataSet("status", array($var));
        $response->addDataSet($dtsVal);
    }
    
    public function innerJoinChecklist(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $checklistAgend = $this->GerenciamentoChkService->innerJoinChecklist($params);
        $dtsVal = new DataSet('GerenciamentoChks', $checklistAgend);
        $response->addDataSet($dtsVal);
    }
    
    public function updateVistoria(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $updatedValues = $this->GerenciamentoChkService->updateVistoria($params);
        $dtsVal = new DataSet("UpdatedValues", array($updatedValues));
        $response->addDataSet($dtsVal);
    }
}

?>